package meerkat.bulletinboard.workers.multiserver;

import com.google.common.util.concurrent.FutureCallback;
import meerkat.bulletinboard.CompleteBatch;
import meerkat.bulletinboard.SingleServerBulletinBoardClient;
import meerkat.protobuf.BulletinBoardAPI.BatchSpecificationMessage;

import java.util.List;


/**
 * Created by Arbel Deutsch Peled on 27-Dec-15.
 */
public class MultiServerReadBatchWorker extends MultiServerGenericReadWorker<BatchSpecificationMessage, CompleteBatch> {

    public MultiServerReadBatchWorker(List<SingleServerBulletinBoardClient> clients,
                                      int minServers, BatchSpecificationMessage payload, int maxRetry,
                                      FutureCallback<CompleteBatch> futureCallback) {

        super(clients, minServers, payload, maxRetry, futureCallback);

    }

    @Override
    protected void doRead(BatchSpecificationMessage payload, SingleServerBulletinBoardClient client) {
        client.readBatch(payload, this);
    }


}
