package meerkat.bulletinboard;

/**
 * Created by Arbel Deutsch Peled on 08-Mar-16.
 * This interface defines the behaviour of a bulletin board synchronizer
 * This is used to make sure that data in a specific instance of a bulletin board server is duplicated to a sufficient percentage of the other servers
 */
public interface BulletinBoardSynchronizer extends Runnable{

    /**
     *
     * @param localClient is a client for the local DB instance
     * @param remoteClient is a client for the remote DBs
     * @param minRedundancy
     */
    public void init(BulletinBoardClient localClient, AsyncBulletinBoardClient remoteClient, float minRedundancy);

    @Override
    public void run();


}
